EncodingGroovyMethods (groovy 2.4.7 API)
Date: 2016-06-03

Package: org.codehaus.groovy.runtime

## [Java] Class EncodingGroovyMethods

- org.codehaus.groovy.runtime.EncodingGroovyMethods

- This class defines all the encoding/decoding groovy methods which enhance the normal JDK classes when inside the Groovy environment. Static methods are used with the first parameter the destination class.

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `static byte[]` | `decodeBase64(String value)` Decode the String from Base64 into a byte array.
    `static byte[]` | `decodeHex(String value)` Decodes a hex string to a byte array.
    `static Writable` | `encodeBase64(Byte[] data, boolean chunked)` Produce a Writable object which writes the Base64 encoding of the byte array.
    `static Writable` | `encodeBase64(Byte[] data)` Produce a Writable object which writes the Base64 encoding of the byte array.
    `static Writable` | `encodeBase64(byte[] data, boolean chunked)` Produce a Writable object which writes the Base64 encoding of the byte array.
    `static Writable` | `encodeBase64(byte[] data)` Produce a Writable object which writes the Base64 encoding of the byte array.
    `static Writable` | `encodeHex(Byte[] data)` Produces a Writable that writes the hex encoding of the Byte[].
    `static Writable` | `encodeHex(byte[] data)` Produces a Writable that writes the hex encoding of the byte[].

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public static byte[] decodeBase64(String value)

      Decode the String from Base64 into a byte array.

      Parameters:
        `value` - the string to be decoded
      Returns:
        the decoded bytes as an array
      Since:
        1.0

    - #### public static byte[] decodeHex(String value)

      Decodes a hex string to a byte array. The hex string can contain either upper case or lower case letters.

      throws:
        NumberFormatException If the string contains an odd number of characters or if the characters are not valid hexadecimal values.
      Parameters:
        `value` - string to be decoded
      Returns:
        decoded byte array

    - #### public static Writable encodeBase64(Byte[] data, boolean chunked)

      Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

      Parameters:
        `data` - Byte array to be encoded
        `chunked` - whether or not the Base64 encoded data should be MIME chunked
      Returns:
        object which will write the Base64 encoding of the byte array
      Since:
        1.5.1

    - #### public static Writable encodeBase64(Byte[] data)

      Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

      Parameters:
        `data` - Byte array to be encoded
      Returns:
        object which will write the Base64 encoding of the byte array
      Since:
        1.0

    - #### public static Writable encodeBase64(byte[] data, boolean chunked)

      Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

      Parameters:
        `data` - byte array to be encoded
        `chunked` - whether or not the Base64 encoded data should be MIME chunked
      Returns:
        object which will write the Base64 encoding of the byte array
      Since:
        1.5.7

    - #### public static Writable encodeBase64(byte[] data)

      Produce a Writable object which writes the Base64 encoding of the byte array. Calling toString() on the result returns the encoding as a String. For more information on Base64 encoding and chunking see `RFC 4648`.

      Parameters:
        `data` - byte array to be encoded
      Returns:
        object which will write the Base64 encoding of the byte array
      Since:
        1.0

    - #### public static Writable encodeHex(Byte[] data)

      Produces a Writable that writes the hex encoding of the Byte[]. Calling toString() on this Writable returns the hex encoding as a String. The hex encoding includes two characters for each byte and all letters are lower case.

      Parameters:
        `data` - byte array to be encoded
      Returns:
        object which will write the hex encoding of the byte array
      See Also:
        Integer.toHexString

    - #### public static Writable encodeHex(byte[] data)

      Produces a Writable that writes the hex encoding of the byte[]. Calling toString() on this Writable returns the hex encoding as a String. The hex encoding includes two characters for each byte and all letters are lower case.

      Parameters:
        `data` - byte array to be encoded
      Returns:
        object which will write the hex encoding of the byte array
      See Also:
        Integer.toHexString